package labs11.assignment2;

import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

public class FileIO {
	
	public void readFromFile() {
		BufferedReader in = null;
		try {
			in = new BufferedReader(new FileReader("text.txt"));
			boolean terminate = false;
			String fileContent = "";
			while ( terminate == false ) {
				String s = in.readLine();
				if ( s != null )
					fileContent = fileContent + s + "\n";
				else
					terminate = true;
			}
			System.out.println("FILE CONTENT:\n" + fileContent);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} finally {
			if ( in != null )
				try {
					in.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
		}
	}
	
	public void readFromFileV2() {
		
		try(BufferedReader in = new BufferedReader(new FileReader("text.txt"))) {
			
			boolean terminate = false;
			String text = "";
			while ( terminate == false ) {
				String s = in.readLine();
				if ( s != null )
					text = text.concat(s + "\n");
				else
					terminate = true;
			}
			System.out.println("FILE CONTENT:\n" + text);
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void writeToFile(String s1, String s2) {
		
		try(PrintWriter out = new PrintWriter(new FileWriter("text2.txt"))) {
			
			out.println(s1);
			out.println(s2);
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void writeNumberToFile() {
		
		try(DataOutputStream out = new DataOutputStream(new FileOutputStream("numbers.out"))){
			int[] numbers = {45, 56, 67, 78, 89};
			for (int i = 0; i < numbers.length; i++) {
				out.writeInt(numbers[i]);
				out.writeChar('\n');
			}
				
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void readNumbersFromFile() {
		
		try(DataInputStream in = new DataInputStream(new FileInputStream("numbers.out"))) {
			
			int sum = 0;
			while ( in.available() > 0 ) {
				int number = in.readInt();
				sum += number;
				in.readChar(); // 'throw away the \n character'
			}
			System.out.println("The sum is: " + sum);
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}











