package labs11.assignment2;

import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

public class FileIO {
	
	public void readFromFile() {
		BufferedReader in = null;
		try {
			in = 
				new BufferedReader(new FileReader("text.txt"));
			boolean terminate = false;
			String fileContent = "";
			while ( !terminate ) {
				String s = in.readLine();
				if ( s == null )
					terminate = true;
				else
					fileContent = fileContent + s + "\n";
			}
			System.out.println("FILE CONTENT:\n" + fileContent);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} finally {
			if ( in != null )
				try {
					in.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
		}
	}
	
	public void readFromFileV2() {
		
		try(BufferedReader in = 
				new BufferedReader(new FileReader("text.txt"))) {
			
			boolean terminate = false;
			String fileContent = "";
			while ( !terminate ) {
				String s = in.readLine();
				if ( s == null )
					terminate = true;
				else
					fileContent = fileContent + s + "\n";
			}
			System.out.println("FILE CONTENT:\n" + fileContent);
			
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void writeToFile(String s1, String s2) {
		
		try(PrintWriter out = 
				new PrintWriter(new FileWriter("text2.txt"))){
			
			out.println(s1);
			out.println(s2);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 
	}
	
	public void printNumbersToFile() {
		
		try(DataOutputStream out = 
				new DataOutputStream(new FileOutputStream("numbers.out"))){
			
			int[] numbers = {45, 56, 67, 78, 89};
			for (int i = 0; i < numbers.length; i++) {
				out.writeInt(numbers[i]);
				out.writeChar('\n');
			}
					
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public void readNumbersFromFile() {
		
		try(DataInputStream in = 
				new DataInputStream(new FileInputStream("numbers.out"))){
			
			int sum = 0;
			while( in.available() > 0 ) {
				int number = in.readInt();
				sum += number;
				in.readChar(); //throwing away the \n character
			}
			System.out.println("The sum is " + sum);
			
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}





